﻿using System;
using System.Linq;
using System.Xml;
using System.Collections.Generic;
using UnityEngine;
using System.IO;

public static class SellEconomicValueMethod
{

    public static void BlockInit(Block block)
    {
        if (block.Properties.Values.ContainsKey("SellEconomicValue"))
        {
            global::Utils.TryParseFloat(block.Properties.Values["SellEconomicValue"], out block.SellEconomicValue);
        }
    }
    public static void CreateBlocks(Block block, global::DynamicProperties dynamicProperties)
    {
        if (dynamicProperties.Values.ContainsKey("SellEconomicValue"))
        {
            block.SellEconomicValue = global::Utils.ParseFloat(dynamicProperties.Values["SellEconomicValue"]);
        }

    }

    public static void ItemClassInit(ItemClass itemClass)
    {
        if (itemClass.Properties.Values.ContainsKey("SellEconomicValue"))
        {
            global::Utils.TryParseFloat(itemClass.Properties.Values["SellEconomicValue"], out itemClass.SellEconomicValue);
        }
    }
    public static void CreateItems(ItemClass itemClass,global::DynamicProperties dynamicProperties)
    {
        if (dynamicProperties.Values.ContainsKey("SellEconomicValue"))
        {
            itemClass.SellEconomicValue = global::Utils.ParseFloat(dynamicProperties.Values["SellEconomicValue"]);
        }
    }
    public static float AutoCalcSellEcoVal(ItemClass itemClass)
    {
        if (itemClass.IsBlock())
        {
            if (global::Block.list[itemClass.Id].SellEconomicValue > 0f)
            {
                return global::Block.list[itemClass.Id].SellEconomicValue;
            }
            if (global::Block.list[itemClass.Id].SellEconomicValue == -1f)
            {
                return 0f;
            }
        }
        else
        {
            if (itemClass.SellEconomicValue > 0f)
            {
                return itemClass.SellEconomicValue;
            }
            if (itemClass.SellEconomicValue == -1f)
            {
                return 0f;
            }
        }
        float num = 0f;
        global::Recipe[] allRecipes = global::CraftingManager.GetAllRecipes(itemClass.GetItemName());
        int num2 = 0;
        if (allRecipes.Length > 0)
        {
            for (int i = 0; i < allRecipes[0].ingredients.Count; i++)
            {
                global::ItemStack itemStack = allRecipes[0].ingredients[i];
                global::ItemClass forId = global::ItemClass.GetForId(itemStack.itemValue.type);
                num += (float)itemStack.count * AutoCalcSellEcoVal(forId);
                num2++;
            }
            float num3 = num;
            float num4;
            if (num2 > 1)
            {
                num4 = (float)allRecipes[0].count;
            }
            else
            {
                num4 = (float)1;
            }
            num = num3 / num4;
        }
        if (num == 0f)
        {
            num = 1f;
        }
        if (itemClass.IsBlock())
        {
            global::Block.list[itemClass.Id].SellEconomicValue = num;
            itemClass.SellEconomicValue = num;
        }
        else
        {
            itemClass.SellEconomicValue = num;
        }
        return num;
    }

}
